Index: boot/arch/arm32/src/mm.c
===================================================================
--- boot/arch/arm32/src/mm.c	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ boot/arch/arm32/src/mm.c	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2007 Pavel Jancik, Michal Kebrt
+ * Copyright (c) 2007 Pavel Jancik
+ * Copyright (c) 2007 Michal Kebrt
  * All rights reserved.
  *
Index: kernel/arch/amd64/include/arch/atomic.h
===================================================================
--- kernel/arch/amd64/include/arch/atomic.h	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/amd64/include/arch/atomic.h	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,5 +1,5 @@
 /*
  * Copyright (c) 2001-2004 Jakub Jermar
- * Copyright (c) 2012      Adam Hraska
+ * Copyright (c) 2012 Adam Hraska
  * All rights reserved.
  *
Index: kernel/arch/arm32/Makefile.inc
===================================================================
--- kernel/arch/arm32/Makefile.inc	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/Makefile.inc	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2007 Jakub Jermar, Michal Kebrt
+# Copyright (c) 2007 Michal Kebrt
 # All rights reserved.
 #
Index: kernel/arch/arm32/include/arch/exception.h
===================================================================
--- kernel/arch/arm32/include/arch/exception.h	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/include/arch/exception.h	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2007 Michal Kebrt, Petr Stepan
+ * Copyright (c) 2007 Michal Kebrt
+ * Copyright (c) 2007 Petr Stepan
  *
  * All rights reserved.
Index: kernel/arch/arm32/include/arch/istate.h
===================================================================
--- kernel/arch/arm32/include/arch/istate.h	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/include/arch/istate.h	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2007 Michal Kebrt, Petr Stepan
- *
+ * Copyright (c) 2007 Michal Kebrt
+ * Copyright (c) 2007 Petr Stepan
  * All rights reserved.
  *
Index: kernel/arch/arm32/include/arch/mm/as.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/as.h	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/include/arch/mm/as.h	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2007 Pavel Jancik, Michal Kebrt
+ * Copyright (c) 2007 Pavel Jancik
+ * Copyright (c) 2007 Michal Kebrt
  * All rights reserved.
  *
Index: kernel/arch/arm32/include/arch/mm/asid.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/asid.h	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/include/arch/mm/asid.h	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2007 Pavel Jancik, Michal Kebrt
+ * Copyright (c) 2007 Pavel Jancik
+ * Copyright (c) 2007 Michal Kebrt
  * All rights reserved.
  *
Index: kernel/arch/arm32/include/arch/mm/frame.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/frame.h	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/include/arch/mm/frame.h	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2007 Pavel Jancik, Michal Kebrt
+ * Copyright (c) 2007 Pavel Jancik
+ * Copyright (c) 2007 Michal Kebrt
  * All rights reserved.
  *
Index: kernel/arch/arm32/include/arch/mm/page.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/page.h	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/include/arch/mm/page.h	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2007 Pavel Jancik, Michal Kebrt
+ * Copyright (c) 2007 Pavel Jancik
+ * Copyright (c) 2007 Michal Kebrt
  * All rights reserved.
  *
Index: kernel/arch/arm32/include/arch/mm/page_armv4.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/page_armv4.h	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/include/arch/mm/page_armv4.h	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2007 Pavel Jancik, Michal Kebrt
+ * Copyright (c) 2007 Pavel Jancik
+ * Copyright (c) 2007 Michal Kebrt
  * Copyright (c) 2012 Jan Vesely
  * All rights reserved.
Index: kernel/arch/arm32/include/arch/mm/page_fault.h
===================================================================
--- kernel/arch/arm32/include/arch/mm/page_fault.h	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/include/arch/mm/page_fault.h	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2007 Pavel Jancik, Michal Kebrt
+ * Copyright (c) 2007 Pavel Jancik
+ * Copyright (c) 2007 Michal Kebrt
  * All rights reserved.
  *
Index: kernel/arch/arm32/include/arch/types.h
===================================================================
--- kernel/arch/arm32/include/arch/types.h	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/include/arch/types.h	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2007 Pavel Jancik, Michal Kebrt
+ * Copyright (c) 2007 Pavel Jancik
+ * Copyright (c) 2007 Michal Kebrt
  * All rights reserved.
  *
Index: kernel/arch/arm32/src/dummy.S
===================================================================
--- kernel/arch/arm32/src/dummy.S	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/src/dummy.S	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,6 @@
 #
-# Copyright (c) 2007 Michal Kebrt, Pavel Jancik, Petr Stepan
+# Copyright (c) 2007 Michal Kebrt
+# Copyright (c) 2007 Pavel Jancik
+# Copyright (c) 2007 Petr Stepan
 # All rights reserved.
 #
Index: kernel/arch/arm32/src/mm/as.c
===================================================================
--- kernel/arch/arm32/src/mm/as.c	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/src/mm/as.c	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2007 Pavel Jancik, Michal Kebrt
+ * Copyright (c) 2007 Pavel Jancik
+ * Copyright (c) 2007 Michal Kebrt
  * All rights reserved.
  *
Index: kernel/arch/arm32/src/mm/frame.c
===================================================================
--- kernel/arch/arm32/src/mm/frame.c	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/src/mm/frame.c	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2007 Pavel Jancik, Michal Kebrt
+ * Copyright (c) 2007 Pavel Jancik
+ * Copyright (c) 2007 Michal Kebrt
  * All rights reserved.
  *
Index: kernel/arch/arm32/src/mm/page.c
===================================================================
--- kernel/arch/arm32/src/mm/page.c	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/src/mm/page.c	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2007 Pavel Jancik, Michal Kebrt
+ * Copyright (c) 2007 Pavel Jancik
+ * Copyright (c) 2007 Michal Kebrt
  * All rights reserved.
  *
Index: kernel/arch/arm32/src/mm/page_fault.c
===================================================================
--- kernel/arch/arm32/src/mm/page_fault.c	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/src/mm/page_fault.c	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2007 Pavel Jancik, Michal Kebrt
+ * Copyright (c) 2007 Pavel Jancik
+ * Copyright (c) 2007 Michal Kebrt
  * All rights reserved.
  *
Index: kernel/arch/arm32/src/userspace.c
===================================================================
--- kernel/arch/arm32/src/userspace.c	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/arm32/src/userspace.c	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2007 Petr Stepan, Pavel Jancik
+ * Copyright (c) 2007 Petr Stepan
+ * Copyright (c) 2007 Pavel Jancik
  * All rights reserved.
  *
Index: kernel/arch/ia32/include/arch/atomic.h
===================================================================
--- kernel/arch/ia32/include/arch/atomic.h	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/ia32/include/arch/atomic.h	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,5 +1,5 @@
 /*
  * Copyright (c) 2001-2004 Jakub Jermar
- * Copyright (c) 2012      Adam Hraska
+ * Copyright (c) 2012 Adam Hraska
  * All rights reserved.
  *
Index: kernel/arch/ia64/include/arch/drivers/kbd.h
===================================================================
--- kernel/arch/ia64/include/arch/drivers/kbd.h	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ kernel/arch/ia64/include/arch/drivers/kbd.h	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2006 Jakub Jermar, Jakub Vana
+ * Copyright (c) 2006 Jakub Jermar
+ * Copyright (c) 2006 Jakub Vana
  * All rights reserved.
  *
Index: uspace/drv/bus/usb/uhci/main.c
===================================================================
--- uspace/drv/bus/usb/uhci/main.c	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ uspace/drv/bus/usb/uhci/main.c	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2011 Vojtech Horky, Jan Vesely
+ * Copyright (c) 2011 Vojtech Horky
+ * Copyright (c) 2011 Jan Vesely
  * All rights reserved.
  *
Index: uspace/drv/hid/usbhid/mouse/mousedev.c
===================================================================
--- uspace/drv/hid/usbhid/mouse/mousedev.c	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ uspace/drv/hid/usbhid/mouse/mousedev.c	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 /*
- * Copyright (c) 2011 Lubos Slovak, Vojtech Horky
+ * Copyright (c) 2011 Lubos Slovak
+ * Copyright (c) 2011 Vojtech Horky
  * All rights reserved.
  *
Index: uspace/lib/c/arch/arm32/src/entry.S
===================================================================
--- uspace/lib/c/arch/arm32/src/entry.S	(revision 6ef9d9a9678ec103514bfbca545cf47e7f817419)
+++ uspace/lib/c/arch/arm32/src/entry.S	(revision 999efa910aa347a786e88adecf88756dfaf9ea65)
@@ -1,4 +1,5 @@
 #
-# Copyright (c) 2007 Michal Kebrt, Pavel Jancik
+# Copyright (c) 2007 Michal Kebrt
+# Copyright (c) 2007 Pavel Jancik
 # All rights reserved.
 #