Index: .gitignore
===================================================================
--- .gitignore	(revision df6ded8c93d4c5e36bb3d1598f5b42fb5553ffe3)
+++ .gitignore	(revision 1033d1fbada20027b76c48da5df9154d3a23932b)
@@ -9,6 +9,4 @@
 *.so.*
 *.d
-*.ag.probe.s
-*.ag.probe.c
 *.pyc
 tag
@@ -16,5 +14,4 @@
 common.h.new
 deps.mk
-Makefile.ag.depend
 /Makefile.config
 /Makefile.common
@@ -46,33 +43,11 @@
 boot/image.raw
 kernel/arch/amd64/_link.ld
-kernel/arch/amd64/include/arch/boot/memmap_struct.h
-kernel/arch/amd64/include/arch/common.h
-kernel/arch/amd64/include/arch/context_struct.h
-kernel/arch/amd64/include/arch/istate_struct.h
-kernel/arch/amd64/include/arch/kseg_struct.h
 kernel/arch/arm32/_link.ld
-kernel/arch/arm32/include/arch/context_struct.h
-kernel/arch/arm32/include/arch/istate_struct.h
 kernel/arch/ia32/_link.ld
-kernel/arch/ia32/include/arch/boot/memmap_struct.h
-kernel/arch/ia32/include/arch/context_struct.h
-kernel/arch/ia32/include/arch/istate_struct.h
 kernel/arch/ia64/_link.ld
-kernel/arch/ia64/include/arch/context_struct.h
-kernel/arch/ia64/include/arch/istate_struct.h
 kernel/arch/mips32/_link.ld
-kernel/arch/mips32/include/arch/context_struct.h
-kernel/arch/mips32/include/arch/fpu_context_struct.h
-kernel/arch/mips32/include/arch/istate_struct.h
 kernel/arch/ppc32/_link.ld
-kernel/arch/ppc32/include/arch/context_struct.h
-kernel/arch/ppc32/include/arch/fpu_context_struct.h
-kernel/arch/ppc32/include/arch/istate_struct.h
 kernel/arch/sparc64/_link.ld
-kernel/arch/sparc64/include/arch/context_struct.h
-kernel/arch/sparc64/include/arch/istate_struct.h
 kernel/arch/abs32le/_link.ld
-kernel/genarch/include/genarch/multiboot/multiboot_info_struct.h
-kernel/genarch/include/genarch/multiboot/multiboot_memmap_struct.h
 kernel/generic/src/debug/real_map.bin
 kernel/kernel.bin
@@ -344,49 +319,32 @@
 uspace/lib/c/arch/amd64/_link-shlib.ld
 uspace/lib/c/arch/amd64/_link.ld
-uspace/lib/c/arch/amd64/include/libarch/common.h
-uspace/lib/c/arch/amd64/include/libarch/fibril_context.h
-uspace/lib/c/arch/amd64/include/libarch/istate_struct.h
 uspace/lib/c/arch/arm32/_link-dlexe.ld
 uspace/lib/c/arch/arm32/_link-loader.ld
 uspace/lib/c/arch/arm32/_link-shlib.ld
 uspace/lib/c/arch/arm32/_link.ld
-uspace/lib/c/arch/arm32/include/libarch/fibril_context.h
-uspace/lib/c/arch/arm32/include/libarch/istate_struct.h
 uspace/lib/c/arch/ia32/_link-dlexe.ld
 uspace/lib/c/arch/ia32/_link-loader.ld
 uspace/lib/c/arch/ia32/_link-shlib.ld
 uspace/lib/c/arch/ia32/_link.ld
-uspace/lib/c/arch/ia32/include/libarch/fibril_context.h
-uspace/lib/c/arch/ia32/include/libarch/istate_struct.h
 uspace/lib/c/arch/ia64/_link-dlexe.ld
 uspace/lib/c/arch/ia64/_link-loader.ld
 uspace/lib/c/arch/ia64/_link-shlib.ld
 uspace/lib/c/arch/ia64/_link.ld
-uspace/lib/c/arch/ia64/include/libarch/fibril_context.h
-uspace/lib/c/arch/ia64/include/libarch/istate_struct.h
 uspace/lib/c/arch/mips32/_link-dlexe.ld
 uspace/lib/c/arch/mips32/_link-loader.ld
 uspace/lib/c/arch/mips32/_link-shlib.ld
 uspace/lib/c/arch/mips32/_link.ld
-uspace/lib/c/arch/mips32/include/libarch/fibril_context.h
-uspace/lib/c/arch/mips32/include/libarch/istate_struct.h
 uspace/lib/c/arch/mips32eb/_link-dlexe.ld
 uspace/lib/c/arch/mips32eb/_link-loader.ld
 uspace/lib/c/arch/mips32eb/_link-shlib.ld
 uspace/lib/c/arch/mips32eb/_link.ld
-uspace/lib/c/arch/mips32eb/include/libarch/fibril_context.h
-uspace/lib/c/arch/mips32eb/include/libarch/istate_struct.h
 uspace/lib/c/arch/ppc32/_link-dlexe.ld
 uspace/lib/c/arch/ppc32/_link-loader.ld
 uspace/lib/c/arch/ppc32/_link-shlib.ld
 uspace/lib/c/arch/ppc32/_link.ld
-uspace/lib/c/arch/ppc32/include/libarch/fibril_context.h
-uspace/lib/c/arch/ppc32/include/libarch/istate_struct.h
 uspace/lib/c/arch/sparc64/_link-dlexe.ld
 uspace/lib/c/arch/sparc64/_link-loader.ld
 uspace/lib/c/arch/sparc64/_link-shlib.ld
 uspace/lib/c/arch/sparc64/_link.ld
-uspace/lib/c/arch/sparc64/include/libarch/fibril_context.h
-uspace/lib/c/arch/sparc64/include/libarch/istate_struct.h
 uspace/lib/c/arch/abs32le/_link-dlexe.ld
 uspace/lib/c/arch/abs32le/_link-loader.ld